from __future__ import annotations

from collections.abc import Callable
from typing import Any, TypeVar

from .choice import FSharpChoice_2
from .fsharp_collections import ComparisonIdentity_Structural, HashIdentity_Structural
from .option import value as value_1
from .system_text import StringBuilder, StringBuilder__Append_Z721C83C5
from .util import IComparer_1, IEqualityComparer, IEqualityComparer_1, dispose, equals, ignore, structural_hash


_T = TypeVar("_T")

_R = TypeVar("_R")

__B = TypeVar("__B")

__A = TypeVar("__A")


class ObjectExpr6(IEqualityComparer):
    def System_Collections_IEqualityComparer_Equals541DA560(self, x: Any = None, y: Any = None) -> bool:
        return equals(x, y)

    def System_Collections_IEqualityComparer_GetHashCode4E60E31B(self, x_1: Any = None) -> int:
        return structural_hash(x_1)


LanguagePrimitives_GenericEqualityComparer: IEqualityComparer = ObjectExpr6()


class ObjectExpr7(IEqualityComparer):
    def System_Collections_IEqualityComparer_Equals541DA560(self, x: Any = None, y: Any = None) -> bool:
        return equals(x, y)

    def System_Collections_IEqualityComparer_GetHashCode4E60E31B(self, x_1: Any = None) -> int:
        return structural_hash(x_1)


LanguagePrimitives_GenericEqualityERComparer: IEqualityComparer = ObjectExpr7()


def LanguagePrimitives_FastGenericComparer(__unit: None = None) -> IComparer_1[Any]:
    return ComparisonIdentity_Structural()


def LanguagePrimitives_FastGenericComparerFromTable(__unit: None = None) -> IComparer_1[Any]:
    return ComparisonIdentity_Structural()


def LanguagePrimitives_FastGenericEqualityComparer(__unit: None = None) -> IEqualityComparer_1[Any]:
    return HashIdentity_Structural()


def LanguagePrimitives_FastGenericEqualityComparerFromTable(__unit: None = None) -> IEqualityComparer_1[Any]:
    return HashIdentity_Structural()


def Operators_Failure(message: str) -> Exception:
    return Exception(message)


def Operators_FailurePattern(exn: Exception) -> str | None:
    return str(exn)


def Operators_NullArg(x: str) -> Any:
    raise Exception(x)


def Operators_Using(resource: Any, action: Callable[[_T], _R]) -> Any:
    try:
        return action(resource)

    finally:
        if equals(resource, None):
            pass

        else:
            copy_of_struct: _T = resource
            dispose(copy_of_struct)


def Operators_Lock(_lockObj: Any, action: Callable[[], __B]) -> Any:
    return action(None)


def Operators_IsNull(value: Any | None = None) -> bool:
    if equals(value, None):
        return True

    else:
        return False


def Operators_IsNotNull(value: Any | None = None) -> bool:
    if equals(value, None):
        return False

    else:
        return True


def Operators_IsNullV(value: Any) -> bool:
    return not (value is not None)


def Operators_NonNull(value: Any | None = None) -> Any:
    if equals(value, None):
        raise Exception()

    else:
        return value


def Operators_NonNullV(value: Any) -> Any:
    if value is not None:
        return value_1(value)

    else:
        raise Exception()


def Operators_NullMatchPattern(value: Any | None = None) -> Any:
    if equals(value, None):
        return FSharpChoice_2(0, None)

    else:
        return FSharpChoice_2(1, value)


def Operators_NullValueMatchPattern(value: Any) -> Any:
    if value is not None:
        return FSharpChoice_2(1, value_1(value))

    else:
        return FSharpChoice_2(0, None)


def Operators_NonNullQuickPattern(value: Any | None = None) -> Any:
    if equals(value, None):
        raise Exception()

    else:
        return value


def Operators_NonNullQuickValuePattern(value: Any) -> Any:
    if value is not None:
        return value_1(value)

    else:
        raise Exception()


def Operators_WithNull(value: Any | None = None) -> Any:
    return value


def Operators_WithNullV(value: Any | None = None) -> Any:
    return value


def Operators_NullV(__unit: None = None) -> Any:
    return None


def Operators_NullArgCheck(argument_name: str, value: Any) -> Any:
    if equals(value, None):
        raise Exception(argument_name)

    else:
        return value


def ExtraTopLevelOperators_LazyPattern(input: Any) -> Any:
    return input.Value


def PrintfModule_PrintFormatToStringBuilderThen(
    continuation: Callable[[], __A], builder: StringBuilder, format: Any
) -> Any:
    def append(s: str, continuation: Any = continuation, builder: Any = builder, format: Any = format) -> __A:
        ignore(StringBuilder__Append_Z721C83C5(builder, s))
        return continuation(None)

    return format.cont(append)


def PrintfModule_PrintFormatToStringBuilder(builder: StringBuilder, format: Any) -> Any:
    def _arrow17(__unit: None = None, builder: Any = builder, format: Any = format) -> None:
        ignore(None)

    return PrintfModule_PrintFormatToStringBuilderThen(_arrow17, builder, format)


__all__ = [
    "LanguagePrimitives_GenericEqualityComparer",
    "LanguagePrimitives_GenericEqualityERComparer",
    "LanguagePrimitives_FastGenericComparer",
    "LanguagePrimitives_FastGenericComparerFromTable",
    "LanguagePrimitives_FastGenericEqualityComparer",
    "LanguagePrimitives_FastGenericEqualityComparerFromTable",
    "Operators_Failure",
    "Operators_FailurePattern",
    "Operators_NullArg",
    "Operators_Using",
    "Operators_Lock",
    "Operators_IsNull",
    "Operators_IsNotNull",
    "Operators_IsNullV",
    "Operators_NonNull",
    "Operators_NonNullV",
    "Operators_NullMatchPattern",
    "Operators_NullValueMatchPattern",
    "Operators_NonNullQuickPattern",
    "Operators_NonNullQuickValuePattern",
    "Operators_WithNull",
    "Operators_WithNullV",
    "Operators_NullV",
    "Operators_NullArgCheck",
    "ExtraTopLevelOperators_LazyPattern",
    "PrintfModule_PrintFormatToStringBuilderThen",
    "PrintfModule_PrintFormatToStringBuilder",
]
