pub mod FSharp {
    use super::*;
    pub mod Core {
        use super::*;
        pub mod LanguagePrimitives {
            use super::*;
            use crate::FSharp::Collections::ComparisonIdentity::Structural;
            use crate::FSharp::Collections::HashIdentity::Structural as Structural_1;
            use crate::Native_::interface_cast;
            use crate::Native_::referenceEquals;
            use crate::Native_::referenceHash;
            use crate::Native_::Any;
            use crate::Native_::Lrc;
            use crate::Native_::LrcPtr;
            use crate::Native_::OnceInit;
            use crate::System::Collections::Generic::IComparer_1;
            use crate::System::Collections::Generic::IEqualityComparer_1;
            use crate::System::Collections::IEqualityComparer;
            pub fn GenericEqualityComparer() -> LrcPtr<dyn IEqualityComparer> {
                static GenericEqualityComparer: OnceInit<LrcPtr<dyn IEqualityComparer>> =
                    OnceInit::new();
                GenericEqualityComparer
                    .get_or_init(|| {
                        #[derive(Clone, Debug)]
                        struct ObjectExpr {}
                        impl core::fmt::Display for ObjectExpr {
                            fn fmt(&self, f: &mut core::fmt::Formatter) -> core::fmt::Result {
                                write!(f, "{}", core::any::type_name::<Self>())
                            }
                        }
                        impl IEqualityComparer for ObjectExpr {
                            fn Equals(&self, x: LrcPtr<dyn Any>, y: LrcPtr<dyn Any>) -> bool {
                                let __self__ = self;
                                referenceEquals(&x, &y)
                            }
                            fn GetHashCode(&self, x_1: LrcPtr<dyn Any>) -> i32 {
                                let __self__ = self;
                                referenceHash(&x_1)
                            }
                        }
                        interface_cast!(LrcPtr::new(ObjectExpr {}), Lrc<dyn IEqualityComparer>,)
                    })
                    .clone()
            }
            pub fn GenericEqualityERComparer() -> LrcPtr<dyn IEqualityComparer> {
                static GenericEqualityERComparer: OnceInit<LrcPtr<dyn IEqualityComparer>> =
                    OnceInit::new();
                GenericEqualityERComparer
                    .get_or_init(|| {
                        #[derive(Clone, Debug)]
                        struct ObjectExpr {}
                        impl core::fmt::Display for ObjectExpr {
                            fn fmt(&self, f: &mut core::fmt::Formatter) -> core::fmt::Result {
                                write!(f, "{}", core::any::type_name::<Self>())
                            }
                        }
                        impl IEqualityComparer for ObjectExpr {
                            fn Equals(&self, x: LrcPtr<dyn Any>, y: LrcPtr<dyn Any>) -> bool {
                                let __self__ = self;
                                referenceEquals(&x, &y)
                            }
                            fn GetHashCode(&self, x_1: LrcPtr<dyn Any>) -> i32 {
                                let __self__ = self;
                                referenceHash(&x_1)
                            }
                        }
                        interface_cast!(LrcPtr::new(ObjectExpr {}), Lrc<dyn IEqualityComparer>,)
                    })
                    .clone()
            }
            pub fn FastGenericComparer<T: PartialOrd + Clone + 'static>(
            ) -> LrcPtr<dyn IComparer_1<T>> {
                Structural::<T>()
            }
            pub fn FastGenericComparerFromTable<T: PartialOrd + Clone + 'static>(
            ) -> LrcPtr<dyn IComparer_1<T>> {
                Structural::<T>()
            }
            pub fn FastGenericEqualityComparer<
                T: core::hash::Hash + PartialEq + Clone + 'static,
            >() -> LrcPtr<dyn IEqualityComparer_1<T>> {
                Structural_1::<T>()
            }
            pub fn FastGenericEqualityComparerFromTable<
                T: core::hash::Hash + PartialEq + Clone + 'static,
            >() -> LrcPtr<dyn IEqualityComparer_1<T>> {
                Structural_1::<T>()
            }
        }
        pub mod Operators {
            use super::*;
            use crate::Choice_::Choice_2;
            use crate::Exception_::finally;
            use crate::Native_::isNull;
            use crate::Native_::Func0;
            use crate::Native_::Func1;
            use crate::Native_::LrcPtr;
            use crate::Native_::Nullable;
            use crate::Option_::getValue;
            use crate::String_::string;
            use crate::System::ArgumentNullException;
            use crate::System::Exception as Exception_1;
            use crate::System::Exception;
            use crate::System::IDisposable;
            use crate::System::NullReferenceException;
            pub fn Failure(message: string) -> LrcPtr<Exception> {
                Exception_1::_ctor__Z721C83C5(message)
            }
            pub fn FailurePattern(exn: LrcPtr<Exception>) -> Option<string> {
                Some(exn.get_Message())
            }
            pub fn NullArg<a: Clone + 'static>(x: string) -> a {
                panic!(
                    "{}",
                    ArgumentNullException::_ctor__Z721C83C5(x).get_Message(),
                )
            }
            pub fn Using<T: IDisposable + Clone + 'static, R: Clone + 'static>(
                resource: LrcPtr<T>,
                action: Func1<LrcPtr<T>, R>,
            ) -> R {
                let __finally__ = finally(Func0::new({
                    let resource = resource.clone();
                    move || {
                        if isNull(resource.clone()) {
                            ()
                        } else {
                            resource.Dispose()
                        }
                    }
                }));
                action(resource.clone())
            }
            pub fn Lock<a: Clone + 'static, b: Clone + 'static>(
                _lockObj: a,
                action: Func0<b>,
            ) -> b {
                action()
            }
            pub fn IsNull<T: Clone + 'static>(value: LrcPtr<T>) -> bool {
                if isNull(value) {
                    true
                } else {
                    false
                }
            }
            pub fn IsNotNull<T: Clone + 'static>(value: LrcPtr<T>) -> bool {
                if isNull(value) {
                    false
                } else {
                    true
                }
            }
            pub fn IsNullV<T: Clone + 'static>(value: Nullable<T>) -> bool {
                !value.is_some()
            }
            pub fn NonNull<T: Clone + 'static>(value: LrcPtr<T>) -> LrcPtr<T> {
                if isNull(value.clone()) {
                    panic!("{}", NullReferenceException::_ctor().get_Message(),)
                } else {
                    value
                }
            }
            pub fn NonNullV<T: Clone + 'static>(value: Nullable<T>) -> T {
                if value.is_some() {
                    getValue(value)
                } else {
                    panic!("{}", NullReferenceException::_ctor().get_Message(),)
                }
            }
            pub fn NullMatchPattern<T: Clone + 'static>(
                value: LrcPtr<T>,
            ) -> LrcPtr<Choice_2<(), LrcPtr<T>>> {
                if isNull(value.clone()) {
                    LrcPtr::new(Choice_2::Choice1Of2::<(), LrcPtr<T>>(()))
                } else {
                    LrcPtr::new(Choice_2::Choice2Of2::<(), LrcPtr<T>>(value))
                }
            }
            pub fn NullValueMatchPattern<T: Clone + 'static>(
                value: Nullable<T>,
            ) -> LrcPtr<Choice_2<(), T>> {
                if value.is_some() {
                    LrcPtr::new(Choice_2::Choice2Of2::<(), T>(getValue(value)))
                } else {
                    LrcPtr::new(Choice_2::Choice1Of2::<(), T>(()))
                }
            }
            pub fn NonNullQuickPattern<T: Clone + 'static>(value: LrcPtr<T>) -> LrcPtr<T> {
                if isNull(value.clone()) {
                    panic!("{}", NullReferenceException::_ctor().get_Message(),)
                } else {
                    value
                }
            }
            pub fn NonNullQuickValuePattern<T: Clone + 'static>(value: Nullable<T>) -> T {
                if value.is_some() {
                    getValue(value)
                } else {
                    panic!("{}", NullReferenceException::_ctor().get_Message(),)
                }
            }
            pub fn WithNull<T: Clone + 'static>(value: T) -> T {
                value
            }
            pub fn WithNullV<T: Clone + 'static>(value: T) -> Option<T> {
                Some(value)
            }
            pub fn NullV<T: Clone + 'static>() -> Option<T> {
                None::<T>
            }
            pub fn NullArgCheck<T: Clone + 'static>(
                argumentName: string,
                value: LrcPtr<T>,
            ) -> LrcPtr<T> {
                if isNull(value.clone()) {
                    panic!(
                        "{}",
                        ArgumentNullException::_ctor__Z721C83C5(argumentName).get_Message(),
                    )
                } else {
                    value
                }
            }
        }
        pub mod ExtraTopLevelOperators {
            use super::*;
            use crate::Native_::LrcPtr;
            use crate::System::Lazy_1;
            pub fn LazyPattern<a: Clone + 'static>(input: LrcPtr<Lazy_1<a>>) -> a {
                input.Force()
            }
        }
    }
}
